## eztrace-contrib 2.2.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)
project(EZTrace
  VERSION 2.2.1
  LANGUAGES C
)


# include CMake modules
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(GNUInstallDirs)
include(CheckLanguage)
include(CheckCSourceCompiles)
include(CTest)

find_package(PkgConfig)

# POLICIES #####################
if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
  cmake_policy(SET CMP0079 NEW)
endif()

# RPATH ########################################
set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_SKIP_BUILD_RPATH FALSE) # use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) # when building, don't use the install RPATH already (but later on when installing)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}") # the RPATH to be used when installing
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# CMakeFind repository
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake_modules)

find_package (OTF2 REQUIRED)
if (NOT OTF2_FOUND)
   message(FATAL_ERROR "libotf2 not found.")
endif()

SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -I${OTF2_INCLUDE_PATH}")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -I${OTF2_INCLUDE_PATH}")

SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE")

# Check if fortran is available
check_language(Fortran)
if(CMAKE_Fortran_COMPILER)
  enable_language(Fortran)
else()
  message(STATUS "No Fortran support")
endif()

# Look for library

#find_package (OpenMP)

# Options to enable/disable modules

option(EZTRACE_ENABLE_MPI      "Enable MPI module"      OFF)
option(EZTRACE_ENABLE_CUDA     "Enable CUDA module"     OFF)
option(EZTRACE_ENABLE_STARPU   "Enable StarPU module"   OFF)
option(EZTRACE_ENABLE_STARPU_API   "Enable StarPU module (using the StarPU profiling API)"   OFF)
option(EZTRACE_ENABLE_OPENMP   "Enable OpenMP module"   OFF)
#option(EZTRACE_ENABLE_PAPI     "Enable PAPI module"     OFF)
option(EZTRACE_ENABLE_POSIXIO  "Enable POSIXIO module"  ON)
option(EZTRACE_ENABLE_PTHREAD  "Enable Pthread module"  ON)
option(EZTRACE_ENABLE_MEMORY   "Enable Memory module"   OFF)
option(EZTRACE_ENABLE_OMPT     "Enable OMPT module"     OFF)
option(EZTRACE_ENABLE_KOKKOS     "Enable Kokkos module"     OFF)
option(EZTRACE_ENABLE_PNETCDF "Enable PNetCDF module" OFF)
option(EZTRACE_ENABLE_NETCDF "Enable NetCDF module" OFF)
option(EZTRACE_ENABLE_IOTRACER "Enable IOtracer module" OFF)
option(EZTRACE_ENABLE_COMPILER_INSTRUMENTATION "Enable compiler-based instrumentation" ON)
option(EZTRACE_ENABLE_PYTHON "Enable Python module" OFF)

SET(MPI_MODULE_NAME "mpi" CACHE STRING "Name of the MPI module")


option(ENABLE_BIN_INSTRUMENTATION "Enable binary instrumentation" OFF)

if(EZTRACE_ENABLE_IOTRACER)
  find_path(IOTRACER_PATH "bcc_iotracer.py" REQUIRED)
endif()

if(ENABLE_BIN_INSTRUMENTATION)
  find_library(BFD NAMES bfd)
  if (NOT BFD)
    message(FATAL_ERROR "libbfd found. This library is required for binary instrumentation")
  endif()

  find_package (LibOpcodes)
  CHECK_LIBRARY_EXISTS(opcodes disassembler "" disassembler_exist)
  if (NOT disassembler_exist)
    message(FATAL_ERROR "libopcodes: disassembler not found. This library is required for binary instrumentation")
  endif()

  try_compile(HAVE_BINUTILS_2_28_OR_OLDER "${CMAKE_BINARY_DIR}/temp" "${CMAKE_SOURCE_DIR}/cmake_modules/tests/test_binutils_2.28.c"
             LINK_LIBRARIES ${BFD_LIBRARY}
             CMAKE_FLAGS 
                  "-DINCLUDE_DIRECTORIES=${BFD_INCLUDE_PATH}"
                  "-DLINK_DIRECTORIES=${BFD_LIB_PATH}")

  try_compile(HAVE_BINUTILS_2_34_OR_OLDER "${CMAKE_BINARY_DIR}/temp" "${CMAKE_SOURCE_DIR}/cmake_modules/tests/test_binutils_2.34.c"
             LINK_LIBRARIES ${BFD_LIBRARY}
             CMAKE_FLAGS 
                  "-DINCLUDE_DIRECTORIES=${BFD_INCLUDE_PATH}"
                  "-DLINK_DIRECTORIES=${BFD_LIB_PATH}")

  try_compile(HAVE_BINUTILS_2_38_50_OR_OLDER "${CMAKE_BINARY_DIR}/temp" "${CMAKE_SOURCE_DIR}/cmake_modules/tests/test_binutils_2.38.c"
             LINK_LIBRARIES ${BFD_LIBRARY}
             CMAKE_FLAGS 
                  "-DINCLUDE_DIRECTORIES=${BFD_INCLUDE_PATH}"
                  "-DLINK_DIRECTORIES=${BFD_LIB_PATH}")

  set(EZTRACE_BINARY_INSTRUMENTATION_FLAG -DENABLE_BINARY_INSTRUMENTATION)

endif()

set (HAVE_DEMANGLE 0)
check_library_exists(iberty cplus_demangle "" cplus_demangle_exist)
if (cplus_demangle_exist)
  find_path (DEMANGLE_INCLUDEDIR NAMES "demangle.h"
    HINTS /usr/include/libiberty/
    )
  if(DEMANGLE_INCLUDEDIR)
    set (HAVE_DEMANGLE 1)
  else()
    message(WARNING " demangle.h not found. C++ symbols will not be demangled")
  endif()
else()
  message(WARNING " libiberty not found. C++ symbols will not be demangled")
endif()

if (EZTRACE_ENABLE_MPI)
  find_program(MPICC mpicc REQUIRED)
  find_program(MPIF90 mpif90)
  add_definitions(-DUSE_MPI)
endif()

if (EZTRACE_ENABLE_STARPU)
  find_package(STARPU "1.2" REQUIRED COMPONENTS HWLOC)
  list(APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
endif()

if (EZTRACE_ENABLE_STARPU_API)
  find_package(STARPU "1.4" REQUIRED COMPONENTS HWLOC)
  list(APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
endif()

# if (EZTRACE_ENABLE_PAPI)
#   find_package (LibPapi REQUIRED)
# endif()
# 

if (EZTRACE_ENABLE_OPENMP)
  find_package (OpenMP REQUIRED)
  find_program(OPARI2 opari2)
  find_program(OPARI2_CONFIG opari2-config)
  IF( NOT OPARI2)
    message(FATAL_ERROR " opari2 was not found. Please download it from https://www.vi-hps.org/projects/score-p#opari2 and install it")
  endIF(NOT OPARI2)
  IF (NOT OPARI2_CONFIG)
    message(FATAL_ERROR " opari2-config was not found. Please download it from https://www.vi-hps.org/projects/score-p#opari2 and install it")
  endIF (NOT OPARI2_CONFIG)
endif()

if (EZTRACE_ENABLE_PNETCDF)
   pkg_check_modules(pnetcdf REQUIRED pnetcdf)
endif()

if (EZTRACE_ENABLE_NETCDF)
   pkg_check_modules(netcdf REQUIRED netcdf)
endif()

if (EZTRACE_ENABLE_OMPT)
  find_package (OpenMP REQUIRED)
  find_package (OMPT REQUIRED)
endif()

if (EZTRACE_ENABLE_KOKKOS)
  find_package (Kokkos REQUIRED CONFIG)
  enable_language(CXX)
endif()

if (EZTRACE_ENABLE_PYTHON)
    set(PYTHON_VENV_HANDLING "FIRST" CACHE STRING "How to handle Python virtual environments (FIRST, ONLY, STANDARD)")
    set(Python3_FIND_VIRTUALENV ${PYTHON_VENV_HANDLING})
    set(PYTHON_EXECUTABLE "Auto" CACHE STRING "Path to the Python interpreter within the virtual environment")
    
    if(NOT PYTHON_EXECUTABLE STREQUAL "Auto")
        set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
    endif()

    find_package(Python3 REQUIRED COMPONENTS Interpreter Development)

    if(NOT Python3_FOUND)
        message(FATAL_ERROR "Python3 was not found. Please download it from https://www.python.org/downloads/ or set PYTHON_EXECUTABLE to the Python interpreter path in your virtual environment.")
    elseif(NOT TARGET Python3::Module)
        message(FATAL_ERROR "Python3 development components were not found. Make sure the Python development headers and libraries are installed on your system.")
    endif()
endif()

#set(THREADS_PREFER_PTHREAD_GLAF ON)
#find_package(Threads REQUIRED)

####################################################
# Some flags for compilation

set (prefix "${CMAKE_INSTALL_PREFIX}")

check_include_files("sys/prctl.h" HAVE_PRCTL_H)
if (NOT HAVE_PRCTL_H)
  set(HAVE_PRCTL_H 0)
endif()

check_include_files("libbacktrace/backtrace.h" HAVE_LIBBACKTRACE)
if (NOT HAVE_LIBBACKTRACE)
  set(HAVE_LIBBACKTRACE 0)
endif()

set(LIBRARY_PATH "${CMAKE_INSTALL_PREFIX}/lib")
if ("${APPLE}")
  set(DYNLIB_EXT "dylib")
  set(LD_PRELOAD_NAME "DYLD_INSERT_LIBRARIES")
  set(LD_LIBRARY_PATH_NAME "DYLD_LIBRARY_PATH")
else() # By default -> Linux
  set(DYNLIB_EXT "so")
  set(LD_PRELOAD_NAME "LD_PRELOAD")
  set(LD_LIBRARY_PATH_NAME "LD_LIBRARY_PATH")
endif()

set(EZTRACE_LIB_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
#set(PPTRACE_BINARY_TYPE "PPTRACE_BINARY_TYPE_BFD")
#set(__PPTRACE_BINARY_TYPE "PPTRACE_BINARY_TYPE_BFD")
#set(abs_top_builddir ${CMAKE_BINARY_DIR})

set(INSTALL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
set(INSTALL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

# Subdirectory
add_subdirectory (src)

add_subdirectory (test/)

include(PrintOpts)

set(EZTRACE_MAN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/doc/man/)
install(DIRECTORY ${EZTRACE_MAN_PAGES} DESTINATION "${CMAKE_INSTALL_MANDIR}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/eztrace.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/eztrace.pc DESTINATION "${INSTALL_PKGCONFIG_DIR}")

message(STATUS "OTF2 version: ${OTF2_VERSION}")

=== src/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(instrumentation)
add_subdirectory(eztrace-lib)
add_subdirectory(modules)
add_subdirectory(plugin_creator)

#####################################################
# eztrace.preload

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/eztrace.preload.in
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace.preload
  @ONLY # ask cmake to change only variables in the form @VAR@ (ie. don't touch the ${VAR} variables, which can be problematic for bash scripts)
  )

list(APPEND SCRIPTS
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace.preload
  )

#####################################################
# eztrace

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/eztrace.c.in ${CMAKE_CURRENT_BINARY_DIR}/eztrace.c)

add_executable(eztrace
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace.c
)

target_compile_options(eztrace
  PRIVATE
    -Wall -Wextra
    -DEZTRACE_ABS_TOP_BUILDDIR="" # TODO
)

target_include_directories(eztrace
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
  )

target_link_libraries(eztrace
  PRIVATE
    ${OTF2_LIBRARY}
    eztrace-instrumentation
    eztrace-lib
)

#####################################################
# eztrace_avail
add_executable(eztrace_avail
  eztrace_avail.c
  )

target_compile_options(eztrace_avail
  PRIVATE
  -Wall -Wextra
  )

target_link_libraries(eztrace_avail
  PRIVATE
    ${OTF2_LIBRARY}
    eztrace-lib
)


################################################


#####################################################

install(PROGRAMS ${SCRIPTS} DESTINATION ${CMAKE_INSTALL_BINDIR})

install(
  TARGETS eztrace eztrace_avail
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== test/CMakeLists.txt ===
enable_testing()

set(EZTRACE_LIBRARY_PATH "${CMAKE_BINARY_DIR}/src/eztrace-lib")
set(TEST_ENVIRONMENT  "EZTRACE_AVAIL_PATH=${CMAKE_BINARY_DIR}/src/eztrace_avail"
  "EZTRACE_CC_PATH=${CMAKE_BINARY_DIR}/src/modules/omp/bin/eztrace_cc"
  "LIBRARY_PATH=$ENV{LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/omp"
  "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/omp"
  "EZTRACE_PATH=${CMAKE_BINARY_DIR}/src/eztrace"
  "OTF2_PRINT_PATH=${OTF2_PRINT}"
  "EZTRACE_TEST_OPTION=-p"
)


add_subdirectory (unit_tests)

if (EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)
  add_subdirectory (compiler_instrumentation)
endif()

if (EZTRACE_ENABLE_KOKKOS)
  add_subdirectory (kokkos)
endif()

if (EZTRACE_ENABLE_MPI)
  add_subdirectory (mpi)
endif()

if (EZTRACE_ENABLE_MEMORY)
  add_subdirectory (memory)
endif()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory (openmp)
endif()

if (EZTRACE_ENABLE_OMPT)
  add_subdirectory (ompt)
endif()

if (EZTRACE_ENABLE_PTHREAD)
  add_subdirectory (pthread)
endif()

if (EZTRACE_ENABLE_POSIXIO)
  add_subdirectory (posixio)
endif()

if (EZTRACE_ENABLE_PYTHON)
  add_subdirectory (python)
endif()

if (EZTRACE_ENABLE_STARPU)
  add_subdirectory (starpu)
endif()

=== src/core/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/include/eztrace-core/eztrace_config.h)

add_library(eztrace-core SHARED
  ezt_demangle.c
  eztrace_array.c
  eztrace_htable.c
  eztrace_sampling.c
  eztrace_config.c
  include/eztrace-core/ezt_demangle.h
  include/eztrace-core/eztrace_array.h
  include/eztrace-core/eztrace_htable.h
  include/eztrace-core/eztrace_list.h
  include/eztrace-core/eztrace_macros.h
  include/eztrace-core/eztrace_sampling.h
  include/eztrace-core/eztrace_spinlock.h
  include/eztrace-core/eztrace_stack.h
  include/eztrace-core/eztrace_types.h
  include/eztrace-core/eztrace_attributes.h
  include/eztrace-core/types.h
  include/eztrace-core/eztrace_utils.h
)

target_include_directories(eztrace-core
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-core
  PRIVATE
    -Wall -Wextra
    -Werror
)

if (HAVE_DEMANGLE)
  target_include_directories(eztrace-core
    PRIVATE
      ${DEMANGLE_INCLUDEDIR}
  )
  target_compile_options(eztrace-core
    PRIVATE
      -DHAVE_DEMANGLE
  )
  target_link_libraries(eztrace-core
    PRIVATE
      iberty
  )
endif()

install(TARGETS eztrace-core EXPORT EZTraceCoreTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-core DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/eztrace-core DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/eztrace-lib/CMakeLists.txt ===
add_library(eztrace-lib SHARED
  eztrace_core.c
  eztrace_otf2.c
  eztrace_internals.c
  eztrace_module.c
  include/eztrace-lib/eztrace.h
  include/eztrace-lib/eztrace_otf2.h
  include/eztrace-lib/eztrace_internals.h
  include/eztrace-lib/eztrace_module.h
  eztrace_pthread_core.c
)

target_include_directories(eztrace-lib
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-lib
  PUBLIC
    -D_GNU_SOURCE
  PRIVATE
    -Wall
)

target_link_libraries(eztrace-lib
  PRIVATE
    ${OTF2_LIBRARY}
    atomic
  PUBLIC
    eztrace-core
    dl
    PRIVATE
    ${CMAKE_DL_LIBS}
    rt
    m
    )

install(TARGETS eztrace-lib EXPORT EZTraceLibTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-lib DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})


if (EZTRACE_ENABLE_MPI)
set(CMAKE_C_COMPILER ${MPICC})
set(CMAKE_Fortran_COMPILER ${MPIF90})
endif()

set(eztrace-mpi_core_SOURCES
  eztrace_mpi_core.c
  include/eztrace-lib/eztrace_mpi.h
  )

if(CMAKE_Fortran_COMPILER)
  # mpif.h may define a bunch of unused parameter which would generate lots of warnings
  set(eztrace-mpi_core_SOURCES ${eztrace-mpi_core_SOURCES}
    eztrace_mpi_core_f.f90  eztrace_mpi_core_fortran.c)
  
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Wno-unused-parameter")
endif()


add_library(eztrace-mpi_core SHARED
  ${eztrace-mpi_core_SOURCES}
)
target_include_directories(eztrace-mpi_core
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-mpi_core
  PUBLIC
    -D_GNU_SOURCE
  PRIVATE
    -Wall 
)

target_link_libraries(eztrace-mpi_core
  PRIVATE
    ${OTF2_LIBRARY}
    atomic
  PUBLIC
    eztrace-core
    dl
    PRIVATE
    ${CMAKE_DL_LIBS}
    rt
    m
    )

install(TARGETS eztrace-mpi_core EXPORT EZTraceLibTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-lib DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== test/compiler_instrumentation/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)

  set(CMAKE_C_FLAGS "-finstrument-functions -O0")
  add_link_options("-rdynamic")

  add_executable(foo foo.c)
  add_test(build_foo "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target foo)

  add_test (NAME compiler_instrumentation_tests COMMAND bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" "${CMAKE_CURRENT_BINARY_DIR}")
  set_tests_properties(compiler_instrumentation_tests PROPERTIES DEPENDS "build_foo_cat")

  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/compiler_instrumentation")

  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/cuda/Makefile ===
BIN=vectorAdd

NVCC ?= nvcc

all: $(BIN)

vectorAdd: vectorAdd.cu
	$(NVCC) -o vectorAdd vectorAdd.cu $(NVCFLAGS) $(NVLDFLAGS)

clean:
	rm -f $(BIN)

=== test/kokkos/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_KOKKOS)
  find_package(Kokkos CONFIG REQUIRED)

  add_executable(sample_kokkos_application sample_kokkos_application.cpp)
  target_include_directories(sample_kokkos_application PRIVATE  Kokkos::kokkos)
  target_link_libraries(sample_kokkos_application Kokkos::kokkos)

  add_test(build_sample_kokkos_application "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target sample_kokkos_application)

  add_test (NAME kokkos_tests COMMAND bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" "${CMAKE_CURRENT_BINARY_DIR}")
  set_tests_properties(kokkos_tests PROPERTIES DEPENDS build_sample_kokkos_application)

  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/kokkos")

  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/kokkos/Makefile ===
LDFLAGS=-lkokkos

BIN=sample_kokkos_application

all: $(BIN)

%: %.cpp
	$(CXX) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== test/memory/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_MEMORY)

  set(CMAKE_C_FLAGS "-pthread")
  set(LINK_OPTIONS  "-pthread")

  add_executable(memory memory.c)
  add_test (build_memory "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target memory)
  add_test (memory_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" "${CMAKE_CURRENT_BINARY_DIR}")
  set_tests_properties(memory_tests PROPERTIES DEPENDS build_memory)
  
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/memory")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/mpi/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_MPI)
  set(CMAKE_C_COMPILER ${MPICC})
  set(CMAKE_Fortran_COMPILER ${MPIF90})

  add_executable(mpi_ping mpi_ping.c)
  add_test (build_mpi_ping "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target mpi_ping)

  add_executable(mpi_pthread mpi_pthread.c)
  TARGET_LINK_LIBRARIES(mpi_pthread pthread)
  add_test (build_mpi_pthread "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target mpi_pthread)

  add_executable(waitall waitall.c)
  add_test (build_waitall "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target waitall)

  add_test (NAME mpi_tests COMMAND bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" "${CMAKE_CURRENT_BINARY_DIR}")
  set_tests_properties(mpi_tests PROPERTIES DEPENDS "build_mpi_ping;build_mpi_pthread;build_waitall")

  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/mpi")

  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/mpi/Makefile ===
MPICC_PATH ?= mpicc
CC=$(MPICC_PATH)

BIN=mpi_ring mpi_multiring mpi_spawn test_mpi waitall waitany persistent mpi_ping allgather mpi_pthread

all: $(BIN)

test: all
	./run.sh

clean:
	rm -f $(BIN)

=== debian/changelog ===
eztrace-contrib (2.2.1-5) unstable; urgency=medium

  * control, rules: Disable kokkos for now.
  * patches/eztrace_abort: Fix build with gcc-15.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 02 Sep 2025 21:14:01 +0200

eztrace-contrib (2.2.1-4) unstable; urgency=medium

  * tests/control: Add MPI smoke test.
  * patches/mpi_core: Fix mpich/openmpi MPI build conflict.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 28 Aug 2025 12:07:25 +0200

eztrace-contrib (2.2.1-3) unstable; urgency=medium

  * control: Disable libpnetcdf-dev build-dependency on 32bit archs instead of
    enabling it on 64bit archs.
  * rules: Disable pnetcdf on 32bit archs instead of enabling it on an explicit
    list.
  * rules: Disable kokkos on archs where it fails to build.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 09:45:48 +0200

eztrace-contrib (2.2.1-2) unstable; urgency=medium

  * control: Avoid build-depending on kokkos where it failed to build.
  * patches/starpu-hip: Fix building against starpu with hip support.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 01:07:02 +0200

eztrace-contrib (2.2.1-1) unstable; urgency=medium

  * New upstream Release.
    - control: Bump cmake build-dep version accordingly.
    - control: Build-Depend on libkokkos-dev, python3, libpython3-dev.
    - control: Make eztrace depend on python3.
    - eztrace.lintian-overrides: Suppress lintian warning.
    - patches/kokkos_openmp: Fix OpenMP detection for kokkos.
    - patches/eztrace.py: Fix running python tests.
    - patches/fortran-no-mpi: Fix build with fortran but no mpi.
    - patches/mpi_mode: Fix running mpi tests.
    - patches/eztrace.py.version: Ensure to run with python3.
    - patches/CXXFLAGS: Fix taking CXXFLAGS into account.
    - patches/otf2: Fix detecting newer otf2 release (Closes: Bug#1114100)
    - rules: Enable kokkos and python backends.
    - rules: Drop cleaning source, bug #64 fixed upstream.
    - libeztrace0.lintian-overrides: Update.
  * copyright: Update.
  * Update standards version to 4.6.2, no changes needed.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 14 Aug 2025 23:10:04 +0200

eztrace-contrib (2.1.1-6) unstable; urgency=medium

  * rules: Make smoketest failure abort immediately, and add comment.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 29 Apr 2025 15:44:45 +0200

eztrace-contrib (2.1.1-5) unstable; urgency=medium

  * watch: Use api to get tags.
    - Add more runpath lintian override.
  * control, rules: Enable ompt on riscv64 and loong64.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 11 Jan 2025 02:28:03 +0100

eztrace-contrib (2.1.1-4) unstable; urgency=medium

  * tests/control: Also disable ompt tests on i386 and riscv64.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 19:41:06 +0100

eztrace-contrib (2.1.1-3) unstable; urgency=medium

  * control, rules: Disable ompt on armhf.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 10:30:33 +0100

eztrace-contrib (2.1.1-2) unstable; urgency=medium

  * control, rules: Disable ompt on i386 and riscv64, enable it on armhf.
  * rules: Avoid confusion between mpich and openmpi builds.
  * rules: Disable binding on the smoke test.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 03:14:44 +0100

=== debian/control ===
Source: eztrace-contrib
Section: contrib/devel
Priority: optional
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 12),
 pkgconf,
 cmake (>= 3.10),
 bc, gawk,
 gfortran,
 libiberty-dev, binutils-dev (>= 2.29~), zlib1g-dev,
 nvidia-cuda-toolkit-gcc (>= 9~),
 libcupti-dev, python3, mesa-common-dev,
 libotf2-trace-dev, otf2-tools,
 opari2, libpomp2-dev,
 clang [amd64 arm64 ppc64el riscv64 loong64], libomp-dev [amd64 arm64 ppc64el riscv64 loong64],
 libstarpu-dev (>= 1.3~), libstarpu-dev (>= 1.4.1+dfsg-7) | libstarpu-dev (<< 1.4~),
#libkokkos-dev [!armel !hppa !hurd-any !m68k !powerpc !sh4],
 libnetcdf-dev, libpnetcdf-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
 libpapi-dev [amd64 arm64 armel armhf i386 powerpc ppc64el mips64el ppc64 x32],
 libmpich-dev, mpi-default-dev, mpi-default-bin,
 python3, libpython3-dev,
Rules-Requires-Root: no
Build-Conflicts: libeztrace0
Standards-Version: 4.6.2
Homepage: https://eztrace.gitlab.io/eztrace/
Vcs-Git: https://salsa.debian.org/debian/eztrace.git -b contrib
Vcs-Browser: https://salsa.debian.org/debian/eztrace/-/tree/contrib

Package: libeztrace0-contrib
Section: contrib/libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeztrace0
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic execution trace generation for HPC - runtime libraries
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files depending on CUDA.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

FAILED=debian/failed

ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
OPENMPI=yes
else
OPENMPI=no
endif

OMPT_ARCHS = amd64 arm64 ppc64el riscv64 loong64

CONFIGURE_ENV=
CONFIGURE=-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)

CONFIGURE_ENV+=CUPTI_ROOT=/usr
CONFIGURE+=-DEZTRACE_ENABLE_CUDA=ON

#export NVCCFLAGS = "-ccbin clang-5.0"
#export NVCCFLAGS = "-ccbin gcc-7"
export NVCCFLAGS = "--compiler-options -std=c++03 --compiler-options -D__GNUC__=7"

ifeq (32,$(DEB_HOST_ARCH_BITS))
CONFIGURE+=-DEZTRACE_ENABLE_PNETCDF=OFF
endif

#ifneq (,$(filter $(DEB_HOST_ARCH),armel hppa hurd-amd64 hurd-i386 m68k powerpc sh4))
CONFIGURE+=-DEZTRACE_ENABLE_KOKKOS=OFF
#endif

%:
	dh $@

# TODO: with starpu >= 1.5, EZTRACE_ENABLE_STARPU_API
override_dh_auto_configure:
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-mpich -- $(CONFIGURE) \
		-DEZTRACE_ENABLE_CUDA=ON \
		-DEZTRACE_ENABLE_MPI=OFF \
		-DEZTRACE_ENABLE_STARPU=OFF \
		-DEZTRACE_ENABLE_OPENMP=OFF \
		-DEZTRACE_ENABLE_POSIXIO=OFF \
		-DEZTRACE_ENABLE_PTHREAD=OFF \
		-DEZTRACE_ENABLE_MEMORY=OFF \
		-DEZTRACE_ENABLE_OMPT=OFF \
		-DEZTRACE_ENABLE_KOKKOS=OFF \
		-DEZTRACE_ENABLE_PNETCDF=OFF \
		-DEZTRACE_ENABLE_NETCDF=OFF \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		-DEZTRACE_ENABLE_PYTHON=OFF \
		$(CONFIGURE)

override_dh_auto_build:
	dh_auto_build -Bbuild-mpich -- -C src/modules/cuda

override_dh_auto_clean:
	dh_auto_clean -Bbuild-mpich -- -C src/modules/cuda

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp -Bbuild-mpich -- -C src/modules/cuda

override_dh_auto_test:
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*src/modules/omp/bin/eztrace_cc\ .*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?\[eztrace_cc\].*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ test_task.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ starpu_.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ .*\ -pthread'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc.*\ memory.c.*\ -o\ memory'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ foo\ foo.c.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?g\+\+\ -o\ vector\ vector.cxx'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*/cc\ .*\ -c\ .*/test/.*.c'
	-verbose=1 dh_auto_test --no-parallel -Bbuild-mpich -- -C src/modules/cuda -k ARGS\+=--extra-verbose

override_dh_dwz:
	:

=== debian/watch ===
version=4
opts="uversionmangle=s/-(rc\d*)$/~$1/,pagemangle=s!"name":"(v?@ANY_VERSION@)"!<a href="https://gitlab.com/@PACKAGE@/@PACKAGE@/-/archive/$1/@PACKAGE@-$1.tar.bz2">!g" \
https://gitlab.com/api/v4/projects/@PACKAGE@%2F@PACKAGE@/repository/tags \
https://gitlab.com/@PACKAGE@/@PACKAGE@/.*/@PACKAGE@-v?@ANY_VERSION@@ARCHIVE_EXT@
